#include-once

; Obacht: Aller hier vorhandener Inhalt ist aus der D2D-UDF von
; eukalyptus zusammengeklaut und von Mars modifiziert.

Global $__oTAR, $__hGUI, $__oFAC, $__hD2D1DLL

Func _VSync_Startup()
	$__hD2D1DLL = DllOpen('d2d1.dll') ; Direct2D Dll
	$__hGUI = GUICreate('VSync', 1, 1, 0, 0, 0x80000000) ; GUI mit der Gre 1x1px oben links im Bildschirm, unsichtbar
	$__oFAC = __D2D_Factory_Create() ; Factory
	$__oTAR = __D2D_Factory_CreateHwndRenderTarget($__oFAC, $__hGUI) ; Erzeugt ein 1x1px groes Target
EndFunc

Func _VSync_Shutdown()
	$__oTAR = Null
	$__oFAC = Null
	GUIDelete($__hGUI)
	DllClose($__hD2D1DLL)
EndFunc

Func _VSync_Wait()
	$__oTAR.BeginDraw()
	$__oTAR.EndDraw(0, 0) ; Der Zaubertrick ist es einfach nichts zu zeichnen, aber trotzdem zu warten als htte man gezeichnet.
EndFunc

Func __D2D_Factory_CreateHwndRenderTarget($oIFactory, $hHwnd)
	Local Const $tagID2D1HwndRenderTarget = 'GetFactory none(ptr*);' & _
		'CreateBitmap hresult(struct;struct*;uint;struct*;ptr*);' & _
		'CreateBitmapFromWicBitmap hresult(struct*;struct*;ptr*);' & _
		'CreateSharedBitmap hresult(struct*;struct*;struct*;ptr*);' & _
		'CreateBitmapBrush hresult(struct*;struct*;struct*;ptr*);' & _
		'CreateSolidColorBrush hresult(struct*;struct*;ptr*);' & _
		'CreateGradientStopCollection hresult(struct*;uint;uint;uint;ptr*);' & _
		'CreateLinearGradientBrush hresult(struct*;struct*;struct*;ptr*);' & _
		'CreateRadialGradientBrush hresult(struct*;struct*;struct*;ptr*);' & _
		'CreateCompatibleRenderTarget hresult(struct*;struct*;struct*;uint;ptr*);' & _
		'CreateLayer hresult(struct*;ptr*);' & _
		'CreateMesh hresult(ptr*);' & _
		'DrawLine none(struct;struct;struct*;float;struct*);' & _
		'DrawRectangle none(struct*;struct*;float;struct*);' & _
		'FillRectangle none(struct*;struct*);' & _
		'DrawRoundedRectangle none(struct*;struct*;float;struct*);' & _
		'FillRoundedRectangle none(struct*;struct*);' & _
		'DrawEllipse none(struct*;struct*;float;struct*);' & _
		'FillEllipse none(struct*;struct*);' & _
		'DrawGeometry none(struct*;struct*;float;struct*);' & _
		'FillGeometry none(struct*;struct*;struct*);' & _
		'FillMesh none(struct*;struct*);' & _
		'FillOpacityMask none(struct*;struct*;uint;struct*;struct*);' & _
		'DrawBitmap none(struct*;struct*;float;uint;struct*);' & _
		'DrawText none(wstr;uint;struct*;struct*;struct*;uint;uint);' & _
		'DrawTextLayout none(struct;struct*;struct*;uint);' & _
		'DrawGlyphRun none(struct;struct*;struct*;uint);' & _
		'SetTransform none(struct*);' & _
		'GetTransform none(struct*);' & _
		'SetAntialiasMode none(uint);' & _
		'GetAntialiasMode uint();' & _
		'SetTextAntialiasMode none(uint);' & _
		'GetTextAntialiasMode uint();' & _
		'SetTextRenderingParams none(struct*);' & _
		'GetTextRenderingParams none(ptr*);' & _
		'SetTags none(uint64;uint64);' & _
		'GetTags none(uint64*;uint64*);' & _
		'PushLayer none(struct*;struct*);' & _
		'PopLayer none();' & _
		'Flush hresult(uint64*;uint64*);' & _
		'SaveDrawingState none(struct*);' & _
		'RestoreDrawingState none(struct*);' & _
		'PushAxisAlignedClip none(struct*;uint);' & _
		'PopAxisAlignedClip none();' & _
		'Clear none(struct*);' & _
		'BeginDraw none();' & _
		'EndDraw hresult(uint64*;uint64*);' & _
		'GetPixelFormat ptr(struct*);' & _
		'SetDpi none(float;float);' & _
		'GetDpi none(float*;float*);' & _
		'GetSize ptr(struct*);' & _
		'GetPixelSize ptr(struct*);' & _
		'GetMaximumBitmapSize uint();' & _
		'IsSupported bool(struct*);' & _
		'CheckWindowState uint();' & _
		'Resize hresult(struct*);' & _
		'GetHwnd hwnd();'
	Local $pHwndRenderTarget, $tRenderTargetProperties = DllStructCreate('struct; uint Type; uint PixelFormat; uint AlphaMode; float DpiX; float DpiY; uint Usage; uint MinLevel; endstruct;')
	Local $tHWNDRenderTargetProperties = DllStructCreate('struct; hwnd Hwnd; uint Width; uint Height; uint PresentOptions; endstruct;')
	$tHWNDRenderTargetProperties.Hwnd = $hHwnd
	$tHWNDRenderTargetProperties.Width = 1
	$tHWNDRenderTargetProperties.Height = 1
	Local $iHResult = $oIFactory.CreateHwndRenderTarget($tRenderTargetProperties, $tHWNDRenderTargetProperties, $pHwndRenderTarget)
	Return ObjCreateInterface($pHwndRenderTarget, '{2cd90698-12e2-11dc-9fed-001143a055f9}', $tagID2D1HwndRenderTarget)
EndFunc

Func __D2D_Factory_Create()
	Local Const $tagID2D1Factory = 'ReloadSystemMetrics hresult();' & _
		'GetDesktopDpi none(float*;float*);' & _
		'CreateRectangleGeometry hresult(struct*;ptr*);' & _
		'CreateRoundedRectangleGeometry hresult(struct*;ptr*);' & _
		'CreateEllipseGeometry hresult(struct*;ptr*);' & _
		'CreateGeometryGroup hresult(uint;struct*;uint;ptr*);' & _
		'CreateTransformedGeometry hresult(struct*;struct*;ptr*);' & _
		'CreatePathGeometry hresult(ptr*);' & _
		'CreateStrokeStyle hresult(struct*;struct*;uint;ptr*);' & _
		'CreateDrawingStateBlock hresult(struct*;struct*;ptr*);' & _
		'CreateWicBitmapRenderTarget hresult(struct*;struct*;ptr*);' & _
		'CreateHwndRenderTarget hresult(struct*;struct*;ptr*);' & _
		'CreateDxgiSurfaceRenderTarget hresult(struct*;struct*;ptr*);' & _
		'CreateDCRenderTarget hresult(struct*;ptr*);'
	Local $tIID_ID2D1Factory = DllStructCreate('struct;ulong Data1;ushort Data2;ushort Data3;byte Data4[8];endstruct')
	DllCall('ole32.dll', 'long', 'CLSIDFromString', 'wstr', '{06152247-6f50-465a-9245-118bfd3b6007}', 'struct*', $tIID_ID2D1Factory)
	Local $aResult = DllCall($__hD2D1DLL, 'int', 'D2D1CreateFactory', 'uint', 0, 'struct*', $tIID_ID2D1Factory, 'uint*', 0, 'ptr*', 0)
	Return ObjCreateInterface($aResult[4], '{06152247-6f50-465a-9245-118bfd3b6007}', $tagID2D1Factory)
EndFunc
